package com.ruoyi.web.modules.trading.controller;

import java.util.List;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.security.access.prepost.PreAuthorize;
import org.springframework.validation.annotation.Validated;
import org.springframework.web.bind.annotation.DeleteMapping;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.PutMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;
import com.ruoyi.common.annotation.Log;
import com.ruoyi.common.core.controller.BaseController;
import com.ruoyi.common.core.domain.AjaxResult;
import com.ruoyi.common.core.page.TableDataInfo;
import com.ruoyi.common.enums.BusinessType;
import com.ruoyi.web.modules.trading.domain.BizSupplier;
import com.ruoyi.web.modules.trading.service.IBizSupplierService;

/**
 * 供应商管理
 */
@RestController
@RequestMapping("/tradeMarket/supplier")
public class BizSupplierController extends BaseController
{
    @Autowired
    private IBizSupplierService bizSupplierService;

    @PreAuthorize("@ss.hasPermi('tradeMarket:supplier:list')")
    @GetMapping("/list")
    public TableDataInfo list(BizSupplier query)
    {
        startPage();
        List<BizSupplier> list = bizSupplierService.selectBizSupplierList(query);
        return getDataTable(list);
    }

    @PreAuthorize("@ss.hasPermi('tradeMarket:supplier:query')")
    @GetMapping("/{id}")
    public AjaxResult getInfo(@PathVariable("id") Long id)
    {
        return success(bizSupplierService.selectBizSupplierById(id));
    }

    @PreAuthorize("@ss.hasPermi('tradeMarket:supplier:add')")
    @Log(title = "供应商管理", businessType = BusinessType.INSERT)
    @PostMapping
    public AjaxResult add(@Validated @RequestBody BizSupplier row)
    {
        row.setCreateBy(getUsername());
        return toAjax(bizSupplierService.insertBizSupplier(row));
    }

    @PreAuthorize("@ss.hasPermi('tradeMarket:supplier:edit')")
    @Log(title = "供应商管理", businessType = BusinessType.UPDATE)
    @PutMapping
    public AjaxResult edit(@Validated @RequestBody BizSupplier row)
    {
        row.setUpdateBy(getUsername());
        return toAjax(bizSupplierService.updateBizSupplier(row));
    }

    @PreAuthorize("@ss.hasPermi('tradeMarket:supplier:remove')")
    @Log(title = "供应商管理", businessType = BusinessType.DELETE)
    @DeleteMapping("/{ids}")
    public AjaxResult remove(@PathVariable Long[] ids)
    {
        return toAjax(bizSupplierService.deleteBizSupplierByIds(ids, getUsername()));
    }

    @PreAuthorize("@ss.hasPermi('tradeMarket:supplier:assignAccount')")
    @Log(title = "供应商分配账号", businessType = BusinessType.INSERT)
    @PostMapping("/assignAccount/{id}")
    public AjaxResult assignAccount(@PathVariable Long id)
    {
        return toAjax(bizSupplierService.assignAccount(id, getUsername()));
    }
}
